/*
  Program: Algoritmus pro hran pikvorek pomoc hledn vzor
  Autor: Radek Pelnek  
  Ploha ke knize "Jak to vyeit",  www.radekpelanek.cz/?jtv
*/


#include <iostream>
#define X 1
#define O 2
#include <cstdlib>
#include <string>

using namespace std;

int pole[22][22];
int moje;

// zakdovn 8 smr vyhledvn, abychom pak nemuseli mt 8 if
int smerX[8] = {0, 1, 1, 1, 0, -1, -1, -1};
int smerY[8] = {-1, -1, 0, 1, 1, 1, 0, -1};


void inicializace() {
  for (int i=0; i<22; i++)
    for (int j=0; j<22; j++)
      pole[i][j] = 0;
}

// naten plnu
void read() {
  char ch;
  cin >> ch;
  if (ch == 'X') moje = X; else moje = O; 

  for (int i=1; i<=20; i++)
    for (int j=1; j<=20; j++) {
      cin >> ch;
      if (ch == 'X') pole[i][j] = X;      
      if (ch == 'O') pole[i][j] = O;
    }
}

void print() {
  if (moje == X) cout << "O"; else cout <<"X";
  cout <<endl;
  for (int i=1; i<=20; i++) {
    for (int j=1; j<=20; j++) {
      if (pole[i][j] == X) { cout << "X";}      
      else if (pole[i][j] == O) { cout << "O";}
      else cout << ".";
    }
    cout << endl;
  }
}

// seznam vzor a pro kad z nich identifikace tahu, na kter tah vede
string strategie[5][10] = { { ".CCCC", "CCCC.", ".CCC.C.", ".CC.CC.", ".C.CCC.", ".CCC.", "C.CC", "CC.C", "",""}, 
			    {"MMMM.", ".MMMM", "MMM.M", "MM.MM", "M.MMM", ".MMM.", "M.MM", "MM.M" }, 
			    { ".M.M.", ".MM..","..MM.", "..MMM", "MMM.." },
			    { ".CC.", ".C." },
			    { "..M..", ".M."} };
int   strategie_tah[5][10] = { { 0, 4, 4, 3, 2, 0, 1, 2, 0, 0, } ,
			       {4, 0, 3, 2, 2, 0, 1, 2, 0, 0},
			       {2, 3, 1, 1, 3, 0, 0, 0, 0, 0},
			       {0, 2, 0,0,0,0,0,0,0,0 },
			       {3, 0, 0,0,0,0,0,0,0,0 }};
int strategie_num[5] = {8, 8, 5, 2, 2};


char dej_char(int pom) {
  if (pom == X) return 'X';
  if (pom == O) return 'O';
  return '.';
}

string preved(string co) {
  string ret = "";
  for (int i=0;i<co.length(); i++) {
    if (co[i] == 'M') ret = ret + dej_char(moje);
    else if (co[i] == 'C') ret = ret + dej_char(3-moje);
    else ret = ret + co[i];    
  }
  return ret;
}

void posun(int* x, int* y, int smer, int pocet) {
  *x = *x + smerX[smer]*pocet;  
  *y = *y + smerY[smer]*pocet;
}

bool out(int x, int y) {
  return (x<=0 || y<= 0|| x>20 ||y>20);
}

bool test(int x, int y, int smer, string co) {
  int i = 0;
  while (i < co.length()) {
    if (dej_char(pole[x][y]) != co[i]) {      
      return false;
    }
    posun(&x, &y, smer, 1);
    if (out(x,y)) return false;
    i++;
  }
  return true;
}

bool hledej(string co, int* x, int* y, int* smer) {
  for (int i=1; i<=20; i++)
    for (int j=1; j<=20; j++)
      for (int s=0; s<8; s++) {
	if (test(i,j,s,co)) {
	  *x = i; *y = j; *smer = s;
	  return true;
	}
      }
  return false;
}

int find_vitez() {
  int x,y,s;
  if (hledej("XXXXX",&x,&y,&s)) return X;
  if (hledej("OOOOO",&x,&y,&s)) return O;
  return 0;
}

bool zkus_tahnout(int ktery, int* x, int* y) {
  int tx, ty, ts; 
  for (int i=0; i<strategie_num[ktery]; i++) {
    if (hledej(preved(strategie[ktery][i]), &tx, &ty, &ts)) {
      *x = tx + smerX[ts]*strategie_tah[ktery][i];
      *y = ty + smerY[ts]*strategie_tah[ktery][i];
      return true;
    }
  }
  return false;
}

void vyber_dle_strategie_random(int* x, int* y) {
  int odchylka = 1;
  do {
    *x = (rand()%(2*odchylka))+10-odchylka;
    *y = (rand()%(2*odchylka))+10-odchylka;
    if (odchylka <9) odchylka++;
  } while (pole[*x][*y] != 0);
}

void vyber_dle_strategie_offence(int* x, int* y) {
  if (zkus_tahnout(0, x, y)) return;
  if (zkus_tahnout(1, x, y)) return;
  if (zkus_tahnout(2, x, y)) return;
  if (zkus_tahnout(4, x, y)) return;
  if (zkus_tahnout(3, x, y)) return;
  vyber_dle_strategie_random(x,y);
}

void decide() {
  int x, y;

  vyber_dle_strategie_offence(&x, &y);
  pole[x][y] = moje;
}

int main() {

  inicializace();
  read();
  decide();
  print();

  return 0;
}
